# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse20037(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'description': 'str',
        'type': 'str',
        'properties': 'dict(str, object)',
        'created_at': 'datetime',
        'sync_status': 'str',
        'expense': 'DeploymentExpense',
        'origin': 'str',
        'depends_on': 'list[str]',
        'state': 'str',
        'current_request': 'DeploymentCurrentRequest',
        'inprogress_requests': 'object'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'type': 'type',
        'properties': 'properties',
        'created_at': 'createdAt',
        'sync_status': 'syncStatus',
        'expense': 'expense',
        'origin': 'origin',
        'depends_on': 'dependsOn',
        'state': 'state',
        'current_request': 'currentRequest',
        'inprogress_requests': 'inprogressRequests'
    }

    def __init__(self, id=None, name=None, description=None, type=None, properties=None, created_at=None, sync_status=None, expense=None, origin=None, depends_on=None, state=None, current_request=None, inprogress_requests=None):  # noqa: E501
        """InlineResponse20037 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._description = None
        self._type = None
        self._properties = None
        self._created_at = None
        self._sync_status = None
        self._expense = None
        self._origin = None
        self._depends_on = None
        self._state = None
        self._current_request = None
        self._inprogress_requests = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.name = name
        if description is not None:
            self.description = description
        self.type = type
        if properties is not None:
            self.properties = properties
        if created_at is not None:
            self.created_at = created_at
        if sync_status is not None:
            self.sync_status = sync_status
        if expense is not None:
            self.expense = expense
        if origin is not None:
            self.origin = origin
        if depends_on is not None:
            self.depends_on = depends_on
        if state is not None:
            self.state = state
        if current_request is not None:
            self.current_request = current_request
        if inprogress_requests is not None:
            self.inprogress_requests = inprogress_requests

    @property
    def id(self):
        """Gets the id of this InlineResponse20037.  # noqa: E501

        Unique identifier of the resource  # noqa: E501

        :return: The id of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse20037.

        Unique identifier of the resource  # noqa: E501

        :param id: The id of this InlineResponse20037.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this InlineResponse20037.  # noqa: E501

        Name of the resource  # noqa: E501

        :return: The name of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse20037.

        Name of the resource  # noqa: E501

        :param name: The name of this InlineResponse20037.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this InlineResponse20037.  # noqa: E501

        A description of the resource  # noqa: E501

        :return: The description of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineResponse20037.

        A description of the resource  # noqa: E501

        :param description: The description of this InlineResponse20037.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def type(self):
        """Gets the type of this InlineResponse20037.  # noqa: E501

        Type of the resource  # noqa: E501

        :return: The type of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this InlineResponse20037.

        Type of the resource  # noqa: E501

        :param type: The type of this InlineResponse20037.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def properties(self):
        """Gets the properties of this InlineResponse20037.  # noqa: E501


        :return: The properties of this InlineResponse20037.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this InlineResponse20037.


        :param properties: The properties of this InlineResponse20037.  # noqa: E501
        :type: dict(str, object)
        """

        self._properties = properties

    @property
    def created_at(self):
        """Gets the created_at of this InlineResponse20037.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this InlineResponse20037.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InlineResponse20037.

        Creation time  # noqa: E501

        :param created_at: The created_at of this InlineResponse20037.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def sync_status(self):
        """Gets the sync_status of this InlineResponse20037.  # noqa: E501

        The current sync status  # noqa: E501

        :return: The sync_status of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._sync_status

    @sync_status.setter
    def sync_status(self, sync_status):
        """Sets the sync_status of this InlineResponse20037.

        The current sync status  # noqa: E501

        :param sync_status: The sync_status of this InlineResponse20037.  # noqa: E501
        :type: str
        """
        allowed_values = ["SUCCESS", "MISSING", "STALE"]  # noqa: E501
        if sync_status not in allowed_values:
            raise ValueError(
                "Invalid value for `sync_status` ({0}), must be one of {1}"  # noqa: E501
                .format(sync_status, allowed_values)
            )

        self._sync_status = sync_status

    @property
    def expense(self):
        """Gets the expense of this InlineResponse20037.  # noqa: E501


        :return: The expense of this InlineResponse20037.  # noqa: E501
        :rtype: DeploymentExpense
        """
        return self._expense

    @expense.setter
    def expense(self, expense):
        """Sets the expense of this InlineResponse20037.


        :param expense: The expense of this InlineResponse20037.  # noqa: E501
        :type: DeploymentExpense
        """

        self._expense = expense

    @property
    def origin(self):
        """Gets the origin of this InlineResponse20037.  # noqa: E501

        Origin of the resource  # noqa: E501

        :return: The origin of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this InlineResponse20037.

        Origin of the resource  # noqa: E501

        :param origin: The origin of this InlineResponse20037.  # noqa: E501
        :type: str
        """
        allowed_values = ["DISCOVERED", "DEPLOYED", "ONBOARDED", "MIGRATED", "SIMULATED", "CCS", "DISCOVERED, ONBOARDED, MIGRATED"]  # noqa: E501
        if origin not in allowed_values:
            raise ValueError(
                "Invalid value for `origin` ({0}), must be one of {1}"  # noqa: E501
                .format(origin, allowed_values)
            )

        self._origin = origin

    @property
    def depends_on(self):
        """Gets the depends_on of this InlineResponse20037.  # noqa: E501

        A list of other resources this resource depends on  # noqa: E501

        :return: The depends_on of this InlineResponse20037.  # noqa: E501
        :rtype: list[str]
        """
        return self._depends_on

    @depends_on.setter
    def depends_on(self, depends_on):
        """Sets the depends_on of this InlineResponse20037.

        A list of other resources this resource depends on  # noqa: E501

        :param depends_on: The depends_on of this InlineResponse20037.  # noqa: E501
        :type: list[str]
        """

        self._depends_on = depends_on

    @property
    def state(self):
        """Gets the state of this InlineResponse20037.  # noqa: E501

        The current state of the resource  # noqa: E501

        :return: The state of this InlineResponse20037.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this InlineResponse20037.

        The current state of the resource  # noqa: E501

        :param state: The state of this InlineResponse20037.  # noqa: E501
        :type: str
        """
        allowed_values = ["PARTIAL", "TAINTED", "OK"]  # noqa: E501
        if state not in allowed_values:
            raise ValueError(
                "Invalid value for `state` ({0}), must be one of {1}"  # noqa: E501
                .format(state, allowed_values)
            )

        self._state = state

    @property
    def current_request(self):
        """Gets the current_request of this InlineResponse20037.  # noqa: E501


        :return: The current_request of this InlineResponse20037.  # noqa: E501
        :rtype: DeploymentCurrentRequest
        """
        return self._current_request

    @current_request.setter
    def current_request(self, current_request):
        """Sets the current_request of this InlineResponse20037.


        :param current_request: The current_request of this InlineResponse20037.  # noqa: E501
        :type: DeploymentCurrentRequest
        """

        self._current_request = current_request

    @property
    def inprogress_requests(self):
        """Gets the inprogress_requests of this InlineResponse20037.  # noqa: E501


        :return: The inprogress_requests of this InlineResponse20037.  # noqa: E501
        :rtype: object
        """
        return self._inprogress_requests

    @inprogress_requests.setter
    def inprogress_requests(self, inprogress_requests):
        """Sets the inprogress_requests of this InlineResponse20037.


        :param inprogress_requests: The inprogress_requests of this InlineResponse20037.  # noqa: E501
        :type: object
        """

        self._inprogress_requests = inprogress_requests

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20037, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20037):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
